open Lambda
open Asttypes
open Typedtree

exception Not_constant (* this is defined in transcore.ml but not exported *)

let extract_constant = function
    Lconst sc -> sc
  | _ -> raise Not_constant

let make_int i = Lconst (Const_base (Const_int i))

let make_block tag ll =
  try
    Lconst (Const_block (tag, List.map extract_constant ll))
  with
    _ -> Lprim (Pmakeblock (tag, Immutable), ll)

let rec transl_list f = function
    [] -> Lconst (Const_pointer 0)
  | x :: xs ->
      let ll = [f x; transl_list f xs] in
      try
	Lconst (Const_block (0, List.map extract_constant ll))
      with
	_ -> Lprim (Pmakeblock (0, Immutable), ll)

let rec transl_const_list f = function
    [] -> Const_pointer 0
  | x :: xs ->
      Const_block (0, [f x; transl_const_list f xs])

