type t = Foo of int
       | Bar of string

type k = Boo

module MOD = struct
  type s = {foo: int; bar: string}
end

open MOD

generic rec print = case $a -> unit of 
  << int ->     unit >> -> print_int
| << float ->   unit >> -> print_float
| << string ->  unit >> -> 
    (fun x -> print_string "\""; print_string x; print_string "\"")
| << char ->    unit >> -> 
    (fun x -> print_string "\'"; print_char x; print_string "\'")
| << $a option -> unit >> ->
    (function
	None -> print_string "None"
      |	Some x -> print_string "Some ("; print x; print_string ")" )
| << t -> unit >> ->
    (function
	Foo x -> print_string "Foo "; print x
      | Bar x -> print_string "Bar "; print x)
| << MOD.s -> unit >> ->
    (function _ -> print_string "MOD.s")  
| << $a list -> unit >> -> 
    (fun lst -> 
      print_string "[";
      let rec printer = function
	  [] -> print_string "]"
	| [x] -> print x; print_string "]"
	| x :: xs -> print x; print_string "; "; printer xs
      in
      printer lst)
| << $a -> unit >> -> 
    (fun x -> print_string "???" )
;;
