(***********************************************************************)
(*                                                                     *)
(*                           Objective Caml                            *)
(*                                                                     *)
(*            Xavier Leroy, projet Cristal, INRIA Rocquencourt         *)
(*                                                                     *)
(*  Copyright 1996 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* $Id: primitive.mli,v 1.4 1997/05/13 14:06:56 xleroy Exp $ *)

(* Description of primitive functions *)

type generic_flag =
    Normal
  | Generic
  | Generic_dynamic
  | Generic_coerce

type description =
  { prim_name: string;         (* Name of primitive  or C function *)
    prim_arity: int;           (* Number of arguments *)
    prim_alloc: bool;          (* Does it allocates or raise? *)
    prim_native_name: string;  (* Name of C function for the nat. code gen. *)
    prim_native_float: bool;   (* Does the above operate on unboxed floats? *)
    prim_generic: generic_flag }       (* Is it a generic primitive ? *)

val parse_declaration: int -> string list -> description
val print_description: description -> unit
